package simulateur;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;


public class CarteCanvas extends Canvas implements MouseListener, MouseMotionListener {
	
	RenderingThread tr = new RenderingThread();
	private Graphics offg;
	private Dimension tailleImage;
    private Image imageCarte = null, offImage = null;
    private int widthCarte, heightCarte;
    boolean clign = true;
    private int indEtoileSel;
    public int[] tx, ty;
    public boolean enableThread;
    static int xSelect, ySelect;
    int decalClign = 3;
    static boolean retour = false;
    private String[] tnoms, tI, tJ, tK;
    public Simulateur app;
    private double grillePasAD = 30; // une ligne pour la grille Asc. droite toutes les xx secondes
    private double grillePasDecl = 5; // une ligne pour la grille Decl toutes les xx minutes
    public static boolean affichageGrille = true;
	protected Image boussole = Toolkit.getDefaultToolkit().getImage(Simulateur.class.getResource("boussole.png"));	   	

    
    /** constructeur **/
	public CarteCanvas(Image image, int widthImage, int heightImage, int[] tx, int[] ty, String[] tnoms, String[] tI, String[] tJ, String[] tK, Simulateur app) {    
    	this.imageCarte = image;
        this.widthCarte = widthImage;
        this.heightCarte = heightImage;
        this.app = app;
        tailleImage = new Dimension(widthImage, heightImage);
        offImage = app.createImage(widthImage, heightImage);
        addMouseListener(this);
        addMouseMotionListener(this);        
        this.tnoms = tnoms;
        this.tx = tx;
        this.ty = ty;
        this.tI = tI;
        this.tJ = tJ;
        this.tK = tK;
        indEtoileSel = -1;
    	enableThread = true;
        tr.start();
    }
    
    public Dimension getPreferredSize() {
        return tailleImage;
    }
    
    public Dimension getMinimumSize() {
        return tailleImage;
    }
    
    
    /** affichage**/
    public void paint(Graphics g) {
        if (offImage != null) {
        	offg = offImage.getGraphics();
            offg.setColor(new Color(230, 221, 212));
            offg.fillRect(0,0,imageCarte.getWidth(this)+90,imageCarte.getHeight(this)+20);
            offg.setColor(Color.black);
        	offg.setFont(new Font(getFont().getName(), 1, 11));
            if (imageCarte != null) {
        		offg.drawImage(imageCarte, 0, 0, this);
        		offg.drawRect(0, 0, imageCarte.getWidth(this), imageCarte.getHeight(this));
        	}
            if (affichageGrille) {
                grilleDecl(offg);
            	grilleAD(offg);
            } else {
            	offg.drawImage(boussole, app.widthCarte+7,(int)((app.heightCarte-100)/2),this);
            }
            dessinerEtoiles(offg);
            if (indEtoileSel != -1) {
            	retour = false;
            	dessinerSelection(offg);
                if (clign) {
                    offg.setColor(new Color(0,230,0));
            	    offg.drawLine(xSelect - decalClign, ySelect - decalClign, xSelect + decalClign, ySelect - decalClign);
                    offg.drawLine(xSelect + decalClign, ySelect - decalClign, xSelect + decalClign, ySelect + decalClign);
                    offg.drawLine(xSelect + decalClign, ySelect + decalClign, xSelect - decalClign, ySelect + decalClign);
                    offg.drawLine(xSelect - decalClign, ySelect + decalClign, xSelect - decalClign, ySelect - decalClign);
                }    
            } else {
            	if (clign && retour) {
            		offg.setColor(Color.magenta);
            	    offg.drawLine(xSelect - decalClign, ySelect - decalClign, xSelect + decalClign, ySelect - decalClign);
                    offg.drawLine(xSelect + decalClign, ySelect - decalClign, xSelect + decalClign, ySelect + decalClign);
                    offg.drawLine(xSelect + decalClign, ySelect + decalClign, xSelect - decalClign, ySelect + decalClign);
                    offg.drawLine(xSelect - decalClign, ySelect + decalClign, xSelect - decalClign, ySelect - decalClign);
            	}
            }
            g.drawImage(offImage, 0, 0, this);
        }
    }
    
    
    public void update(Graphics g) {
        paint(g);
    }  
    
    
    /** activation/desactivation de l'affichage des grilles **/
    public void affichageGrille() {
    	affichageGrille = !affichageGrille;
    	repaint();
    }

    
    /** affichage "grille & echelle" pour ascenscion droite **/
    public void grilleAD(Graphics g) {
        double facteur = 240.0/grillePasAD;
    	double minAD = Math.min(app.stringToCoord(app.strAd1,true),app.stringToCoord(app.strAd2,true));
    	double maxAD = Math.max(app.stringToCoord(app.strAd1,true),app.stringToCoord(app.strAd2,true));    	
    	double ecartWidth = Math.abs(app.stringToCoord(app.strAd2,true) - app.stringToCoord(app.strAd1,true));
    	int valMin = (int)Math.ceil(minAD*facteur);
    	int valMax = (int)Math.floor(maxAD*facteur);
    	g.setColor(new Color(121,109,95));
    	for (int i=valMin; i<=valMax; i++) {
        	int absc = (int)Math.rint((((double)i/facteur - minAD) / (ecartWidth)) * (app.widthCarte)) ;
        	g.drawLine(app.widthCarte-absc, 0, app.widthCarte-absc, app.heightCarte);
            int thisAbsc = app.widthCarte-absc-g.getFontMetrics().stringWidth(app.coordToFString((i/(facteur)),true))/2+4;
            if (absc<=g.getFontMetrics().stringWidth(app.coordToFString((i/(facteur)),true))/2) {thisAbsc=2;}
        	g.drawString(app.coordToFString((i/(facteur)),true),thisAbsc,app.heightCarte+12);
        }
    }
    
    
    /** affichage "grille & echelle" pour dclinaison **/
    public void grilleDecl(Graphics g) {
        double facteur = 60.0/grillePasDecl;
    	double minDecl = Math.min(app.stringToCoord(app.strDecl1,false),app.stringToCoord(app.strDecl2,false));
    	double maxDecl = Math.max(app.stringToCoord(app.strDecl1,false),app.stringToCoord(app.strDecl2,false));    	
    	double ecartHeight = Math.abs(app.stringToCoord(app.strDecl2,false) - app.stringToCoord(app.strDecl1,false));
    	int valMin = (int)Math.ceil(minDecl*facteur);
    	int valMax = (int)Math.floor(maxDecl*facteur);
    	g.setColor(new Color(121,109,95));
    	for (int i=valMin; i<=valMax; i++) {
        	int ord = (int)Math.floor((((double)i/facteur - minDecl) / (ecartHeight)) * (app.heightCarte)) ;
        	g.drawLine(0, app.heightCarte-ord, app.widthCarte, app.heightCarte-ord);
        	int thisOrdo = app.heightCarte - ord;
			if (thisOrdo<=5) thisOrdo+=10;
            else if (thisOrdo>=app.heightCarte-5) thisOrdo-=2;
            else thisOrdo+=4;
        	g.drawString(app.coordToFString((i/(facteur)),false),app.widthCarte+5,thisOrdo);
        }
    }    

    
    /** ajoute les etoiles a la carte **/
    protected void dessinerEtoiles(Graphics g) {
        g.setColor(Color.red);
        for (int i=0; i<tx.length; i++) {
        	g.drawLine(tx[i]-3, ty[i], tx[i]+3, ty[i]);
            g.drawLine(tx[i],ty[i]-3,tx[i],ty[i]+3);
        }
        g.setColor(Color.black);
    }
 
    
    /** affiche nom etoile passage souris **/
    protected void dessinerSelection(Graphics g) {
        int xNameSelect, yNameSelect;
    	xSelect = tx[indEtoileSel];
        ySelect = ty[indEtoileSel];
        String nom = tnoms[indEtoileSel];
        int w = g.getFontMetrics().stringWidth(nom);
        if (xSelect + w + 6 > imageCarte.getWidth(this)) xNameSelect = imageCarte.getWidth(this)- w - 9;
        else xNameSelect = xSelect;
        if (ySelect + 25 > imageCarte.getHeight(this)) yNameSelect = ySelect - 28;
        else yNameSelect = ySelect;
        g.setColor(new Color(135,159,207));
        g.fillRoundRect(xNameSelect+6, yNameSelect+6, w+4, 18, 6, 6);
        g.setColor(Color.white);
        g.drawString(nom, xNameSelect+8, yNameSelect+7+12);
    }

    
    /** changement de carte **/
    public void changerCarte(Image image, int widthImage, int heightImage, int[] tx, int[] ty, String[] tnoms, String[] tI, String[] tJ, String[] tK) {
        retour = false;
    	this.imageCarte = image;
        this.widthCarte = widthImage;
        this.heightCarte = heightImage;
        this.tnoms = tnoms;
        this.tx = tx;
        this.ty = ty;
        this.tI = tI;
        this.tJ = tJ;
        this.tK = tK;
        indEtoileSel = -1;
        repaint();
    }
  
    
    /** cherche si une etoile est presente (la plus proche si plusieurs) dans une zone entourant la souris **/
    protected int chercherEtoile(int xs, int ys) {
        double distmin = 1E10;
        int indice = -1;
        int xe, ye;
        int xemxs, yemys;
        double tempdistmin;
        for (int i=0; i<tnoms.length; i++) {
            xe = tx[i];
            ye = ty[i];
            xemxs = xe-xs;
            yemys = ye-ys;
            tempdistmin = xemxs*xemxs + yemys*yemys;
            if (tempdistmin < distmin) {
                distmin = tempdistmin;
                indice = i;
            }
        }
        if (distmin < 800)
            return(indice);
        else
            return(-1);
    }

    
    /** clic souris sur la carte **/
    public void mouseClicked(MouseEvent e) {
    	int indice = chercherEtoile(e.getX(), e.getY());
    	if (e.getX()<=app.widthCarte && e.getY()<=app.heightCarte && indice!=-1) {
    		Frame frame=getFrame();
    		if (frame!=null)frame.setCursor(0);
    		app.selectEtoile = tnoms[indice];
    		app.selectAbsc = tx[indice];
    		app.selectOrdo = ty[indice];
    		app.selectI = tI[indice];
    		app.selectJ = tJ[indice];
    		app.selectK = tK[indice];
    		app.accesCaractEtoile();
    		enableThread = false;
    	}
    }
    
    public void mousePressed(MouseEvent e) {
    }
    
    public void mouseReleased(MouseEvent e) {
    }
    
    public void mouseEntered(MouseEvent e) {
    }
    
    public void mouseExited(MouseEvent e) {
    }
    
    public void mouseDragged(MouseEvent e) {
    }
    
    /** mouvement souris sur la carte **/
    public void mouseMoved(MouseEvent e) {
    	int indice = chercherEtoile(e.getX(), e.getY());
    	// utilisation d'un objet de type Frame pour curseur sous java 1.0
    	Frame frame=getFrame();
    	if (frame!=null) {
    		if (indice!=-1) frame.setCursor(12);
    		else frame.setCursor(0);
    	}
    	if (indice != indEtoileSel) {
            indEtoileSel = indice;
            repaint();
        }
    	if (e.getX()<=app.widthCarte && e.getY()<=app.heightCarte) {
    		app.LabelAD.setText(Messages.get("Asc_droite") + " " + app.coordToFString(app.AbscInCoord(e.getX()),true));
    		app.LabelDecl.setText(Messages.get("Dclinaison") + " " + app.coordToFString(app.OrdoInCoord(e.getY()),false));
    	}
    }
    
    /** utilise pour curseur souris **/
    private Frame getFrame() {
    	Component component=this;
    	do{component=component.getParent();}
    	while(!(component instanceof Frame));
    	return (Frame)component;
    }
    

    class RenderingThread extends Thread {
    	public void run(){
            while(enableThread){
               try {
               	  clign=!clign;
                  if (clign && decalClign==3) decalClign=4;
                  else if (clign) decalClign=3;
                  repaint(); 
                  if (decalClign==4) sleep(150);
                  else sleep(500);
               } catch ( Exception e ) {} 
            }
         }
     }  
}
