package simulateur;

import java.applet.Applet;
import java.io.*; 
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.text.DecimalFormat;
import java.util.Vector;
import xml.*;

public class Simulateur extends Applet implements ItemListener, ActionListener { 

	public int widthCarte, heightCarte;
    private Image graph;
    private graphCanvas graphC;
    private CarteCanvas carteC;
    private CheckboxGroup choixCarte; 
    private Checkbox chkbCentre, chkbAnticentre, chkbGrille, actualChkbImage;
	public String strAd1, strAd2, strDecl1, strDecl2;
	public Label LabelAD, LabelDecl, txtGraph1, txtGraph2, txtGraph3, txtGraph4, txtGraph5, txtGraph6, txtGraph7, txtGraph8;
    protected Image boussole = Toolkit.getDefaultToolkit().getImage(Simulateur.class.getResource("boussole.png"));
    protected Image imageCentre = Toolkit.getDefaultToolkit().getImage(Simulateur.class.getResource("centre.jpg"));	
    protected Image imageAnticentre = Toolkit.getDefaultToolkit().getImage(Simulateur.class.getResource("anticentre.jpg"));	
    private int xCentre[], yCentre[], xAntiCentre[], yAntiCentre[];
    private String nomCentre[], valICentre[], valJCentre[], valKCentre[];
    private String nomAntiCentre[], valIAntiCentre[], valJAntiCentre[], valKAntiCentre[];
    public String typeCarte = Messages.get("Centre");
    public Panel mainPanel;    
    public Button retourCarte, continuerTransit, retourCaractEtoile, relGraph ;
    public String selectEtoile, selectI, selectJ, selectK, selectTypeSpectral = "??";
    public int selectAbsc, selectOrdo;
    public int calcValRayon;
    public String[] RayonEtoile, MasseEtoile, LumEtoile, TempEtoile;
    public int nbVarPhotTot = 57;
    public String[] photTotType = new String[nbVarPhotTot], photTotIJ = new String[nbVarPhotTot], photTotJK = new String[nbVarPhotTot];
    static private DecimalFormat df2 = new DecimalFormat("#######0.00");
    public String ac_AD1 = "6:47:50.58", ac_AD2 = "6:48:47.35", ac_Decl1 = "-1:26:9.0", ac_Decl2 = "-1:12:6.0";
    public String c_AD1 = "19:04:50.70", c_AD2 = "19:05:47.35", c_Decl1 = "-1:37:46.6", c_Decl2 = "-1:23:43.2";

    
    /** constructeur **/
    public Simulateur() {
    }

    
    /** initialisation **/
    public void init() {
    	 strAd1 = c_AD1; //avt : getParameter("ic-ad1");
		 strAd2 = c_AD2;
		 strDecl1 = c_Decl1;
		 strDecl2 = c_Decl2;
		 chargementImages();
		 parsingCatalogXML("etoiles.xml");
		 parsingPhoTot("photTot.dat"); 
		 champCorot();
	}

    
    /** parsing du fichier .dat**/
    public void parsingPhoTot(String file) {
    	URL thisURL = Simulateur.class.getResource(file);
        try {
        	URLConnection yc = thisURL.openConnection();
        	BufferedReader br = new BufferedReader(new InputStreamReader(yc.getInputStream()));
        	String ligne;
		    int num_ligne = 0;
	        while ((ligne=br.readLine())!=null) {
		        int debut = 0;
		        int composant = 1;
		      	for (int i=0; i<ligne.length(); i++) {
		            int separator = ligne.indexOf(";",i);
		         	if (separator!= -1) {
		         		if (composant==1) photTotType[num_ligne]=ligne.substring(debut,separator);
		         		else if (composant==2) photTotIJ[num_ligne]=ligne.substring(debut,separator);
		         		else if (composant==3) photTotJK[num_ligne]=ligne.substring(debut,separator);
		         	    i=separator;
		         	    debut = i+1;
		         	    composant++;
		         	}
		        }
		        num_ligne++;
		    } 
		    br.close();
	    }
		catch (Exception e) {
		    System.err.println(e.toString());
		} 
    }

    
    /** Panel champs Corot **/
    public void champCorot() {
  	     setFont(new Font(getFont().getName(), 1, 12));
	     setBackground(new Color(230, 221, 212));
		 setForeground(Color.black);
		 mainPanel = new Panel(new GridBagLayout());
	     GridBagConstraints c = new GridBagConstraints();
	     c.gridwidth = 1;
	     c.gridx = 0;
	     c.gridy = 0;
		 if (typeCarte.equals(Messages.get("Centre"))) carteC = new CarteCanvas(imageCentre, widthCarte+90, heightCarte+20, xCentre, yCentre, nomCentre, valICentre, valJCentre, valKCentre, this);
	     else carteC = new CarteCanvas(imageAnticentre, widthCarte+90, heightCarte+20, xAntiCentre, yAntiCentre, nomAntiCentre, valIAntiCentre, valJAntiCentre, valKAntiCentre, this);
		 mainPanel.add(carteC, c);
		 choixCarte = new CheckboxGroup();
		 Panel choixPanel = new Panel(new GridBagLayout());
		 GridBagConstraints c_choix = new GridBagConstraints();
		 c_choix.gridx = 0;
		 c_choix.gridy = 0;
		 c_choix.anchor = GridBagConstraints.WEST;
	     chkbCentre = new Checkbox(Messages.get("visualiser_centre"), choixCarte, typeCarte.equals("Centre"));
	     chkbCentre.addItemListener(this);
	     choixPanel.add(chkbCentre, c_choix);
	     c_choix.gridy = 1;
	     chkbAnticentre = new Checkbox(Messages.get("visualiser_anti-centre"), choixCarte, !typeCarte.equals("Centre"));
	     chkbAnticentre.addItemListener(this);		 
	     choixPanel.add(chkbAnticentre, c_choix);		 
	     c_choix.gridy = 2;
	     chkbGrille = new Checkbox(Messages.get("Afficher_grille"), carteC.affichageGrille);
	     chkbGrille.addItemListener(this);
	     choixPanel.add(chkbGrille, c_choix);
		 c_choix.gridx = 1;
		 c_choix.gridy = 0;	  
		 c_choix.gridheight = 3;
		 choixPanel.add(new Label("                 "), c_choix);
		 c_choix.gridheight = 1;
		 c_choix.gridx = 2;
		 c_choix.gridy = 0;
		 Label LabelC = new Label(Messages.get("Coordonnes"));
		 LabelC.setForeground(new Color(141,119,95));
		 choixPanel.add(LabelC, c_choix);
		 c_choix.gridy = 1;	
	     LabelAD = new Label(Messages.get("Asc_droite_inconnue"));
	     LabelAD.setForeground(new Color(141,119,95));
	     choixPanel.add(LabelAD, c_choix);
		 c_choix.gridy = 2;	
	     LabelDecl = new Label(Messages.get("Dclinaison_inconnue"));
	     LabelDecl.setForeground(new Color(141,119,95));
	     choixPanel.add(LabelDecl, c_choix);
		 c.gridy = 1;
		 mainPanel.add(choixPanel, c);
		 add(mainPanel);		 
    }

	
    /** chargement prlable des images **/ 
    protected void chargementImages()
	{
        MediaTracker mediatracker = new MediaTracker(this);
        mediatracker.addImage(imageCentre, 0);
        mediatracker.addImage(imageAnticentre, 1);
        mediatracker.addImage(boussole, 2);
        try {
            mediatracker.waitForAll();
        }
        catch(InterruptedException interruptedexception) {
            System.err.println("InterruptedException: " + interruptedexception.getMessage());
        }
        widthCarte = imageCentre.getWidth(this);
        heightCarte = imageCentre.getHeight(this);
	}

	
    /** parsing du calague xml contenant les donnes des toiles **/
	protected void parsingCatalogXML(String fichierXML) 
	{
		XMLTree catalogTree = new XMLTree(null, "", null, "");
		URL urlDoc = Simulateur.class.getResource(fichierXML);
		//urlDoc = new URL(getDocumentBase(), fichierXML); // si mis en param dans test.html et fourni en plus du .jar
        Parser_XML parser_xml = new Parser_XML(urlDoc, System.out, catalogTree);
        parser_xml.parse(0);
        if(!"ETOILES".equalsIgnoreCase(catalogTree.tag)) {
            System.err.println("Mauvais fichier XML !");
            return;
        }
        Vector vector1 = new Vector();
        Vector vector2 = new Vector();
        Vector vector3 = new Vector();
        Vector vector4 = new Vector();
        Vector vector5 = new Vector();
        Vector vector6 = new Vector();
        Vector vector7 = new Vector();
        Vector vector8 = new Vector();
        Vector vector9 = new Vector();
        Vector vector10 = new Vector();
        Vector vector11 = new Vector();
        Vector vector12 = new Vector();
        for(XMLTree tempoTree = catalogTree.first_child; tempoTree != null; tempoTree = tempoTree.next_brother) {        
            String s1 = tempoTree.getAttVal("nom");
            String s2 = tempoTree.getNode("AD").val;
            String s3 = tempoTree.getNode("DEC").val;
            String s4 = tempoTree.getNode("I").val;
            String s5 = tempoTree.getNode("J").val;
            String s6 = tempoTree.getNode("K").val;            
            if(starInChamp(s2, s3, c_AD1, c_AD2, c_Decl1, c_Decl2))
            {
            	vector1.addElement(s1);
                vector2.addElement(String.valueOf(CoordInAbsc(Double.valueOf(s2).doubleValue(),stringToCoord(c_AD1,true),stringToCoord(c_AD2,true))));
                vector3.addElement(String.valueOf(CoordInOrdo(Double.valueOf(s3).doubleValue(),stringToCoord(c_Decl1,false),stringToCoord(c_Decl2,false))));
                vector4.addElement(s4);
                vector5.addElement(s5);
                vector6.addElement(s6);
            } 
            else if(starInChamp(s2, s3, ac_AD1, ac_AD2, ac_Decl1, ac_Decl2))
            {
                vector7.addElement(s1);
                vector8.addElement(String.valueOf(CoordInAbsc(Double.valueOf(s2).doubleValue(),stringToCoord(ac_AD1,true),stringToCoord(ac_AD2,true))));
                vector9.addElement(String.valueOf(CoordInOrdo(Double.valueOf(s3).doubleValue(),stringToCoord(ac_Decl1,false),stringToCoord(ac_Decl2,false))));
                vector10.addElement(s4);
                vector11.addElement(s5);
                vector12.addElement(s6);                
            } 
            else System.out.println("La plante " + s1 + " du catalogue ne semble appartenir a aucun des deux champs ?!");   	
        }
        if (vector2.size()!=0) {
        	nomCentre = new String[vector1.size()];
        	xCentre = new int[vector2.size()];
        	yCentre = new int[vector3.size()];
        	valICentre = new String[vector4.size()];
        	valJCentre = new String[vector5.size()];
        	valKCentre = new String[vector6.size()];
        	for(int k = 0; k < vector2.size(); k++) {
        		nomCentre[k]=(String)vector1.elementAt(k);
        		xCentre[k]=Integer.parseInt((String)vector2.elementAt(k));
        	    yCentre[k]=Integer.parseInt((String)vector3.elementAt(k));
        	    valICentre[k]=(String)vector4.elementAt(k);
        	    valJCentre[k]=(String)vector5.elementAt(k);
        	    valKCentre[k]=(String)vector6.elementAt(k);
            }
        }
        if (vector8.size()!=0) {
        	nomAntiCentre = new String[vector7.size()];
        	xAntiCentre = new int[vector8.size()];
        	yAntiCentre = new int[vector9.size()];
        	valIAntiCentre = new String[vector10.size()];
        	valJAntiCentre = new String[vector11.size()];
        	valKAntiCentre = new String[vector12.size()];
        	for(int k = 0; k < vector8.size(); k++) {
        		nomAntiCentre[k]=(String)vector7.elementAt(k);
        		xAntiCentre[k]=Integer.parseInt((String)vector8.elementAt(k));
        	    yAntiCentre[k]=Integer.parseInt((String)vector9.elementAt(k));
        	    valIAntiCentre[k]=(String)vector10.elementAt(k);
        	    valJAntiCentre[k]=(String)vector11.elementAt(k);
        	    valKAntiCentre[k]=(String)vector12.elementAt(k);
            }
        }       
	}

	
	/** boolean specifiant si des coords appartiennent a un champ donnee **/
	public boolean starInChamp(String stAD, String stDecl, String Ad1, String Ad2, String Decl1, String Decl2) {
    	double minAscDroite = Math.min(stringToCoord(Ad1,true),stringToCoord(Ad2,true));
    	double maxAscDroite = Math.max(stringToCoord(Ad1,true),stringToCoord(Ad2,true));
    	double minDecl = Math.min(stringToCoord(Decl1,false),stringToCoord(Decl2,false));
    	double maxDecl = Math.max(stringToCoord(Decl1,false),stringToCoord(Decl2,false));
    	if (Double.valueOf(stAD).doubleValue()<=maxAscDroite && Double.valueOf(stAD).doubleValue()>=minAscDroite
			&& Double.valueOf(stDecl).doubleValue()<=maxDecl && Double.valueOf(stDecl).doubleValue()>=minDecl) return true;
    	else return false;
	}

	
	/** Action sur un item **/
    public void itemStateChanged(ItemEvent itemevent)
    {
    	if (itemevent.getSource() == chkbGrille) {
    		carteC.affichageGrille();
    	}
    	else {
    		Checkbox selectedItem = choixCarte.getSelectedCheckbox();
            if(selectedItem != actualChkbImage)
            {
            	actualChkbImage = selectedItem;
            	if(actualChkbImage == chkbCentre) {
            		typeCarte = Messages.get("Centre");
            		LabelAD.setText(Messages.get("Asc_droite_inconnue"));
            		LabelDecl.setText(Messages.get("Dclinaison_inconnue"));
               	 	strAd1 = c_AD1;
               	 	strAd2 = c_AD2;
        		 	strDecl1 = c_Decl1;
        		 	strDecl2 = c_Decl2;
                    widthCarte = imageCentre.getWidth(this);
                    heightCarte = imageCentre.getHeight(this);
            		carteC.changerCarte(imageCentre, widthCarte+90, heightCarte+20, xCentre, yCentre, nomCentre, valICentre, valJCentre, valKCentre);                    
            	}	
                else {
                	typeCarte = Messages.get("AntiCentre");
                	LabelAD.setText(Messages.get("Asc_droite_inconnue"));
                	LabelDecl.setText(Messages.get("Dclinaison_inconnue"));
               	 	strAd1 = ac_AD1;
               	 	strAd2 = ac_AD2;
        		 	strDecl1 = ac_Decl1;
        		 	strDecl2 = ac_Decl2;                	
                    widthCarte = imageAnticentre.getWidth(this);
                    heightCarte = imageAnticentre.getHeight(this);
                	carteC.changerCarte(imageAnticentre, widthCarte+90, heightCarte+20, xAntiCentre, yAntiCentre, nomAntiCentre, valIAntiCentre, valJAntiCentre, valKAntiCentre);                    
                }	
            }    		
    	}
    }
    
    
    /** action sur un bouton **/
    public void actionPerformed(ActionEvent e)
    {
        if (e.getSource() == retourCarte) {
            retourCarte();
        }
        else if (e.getSource() == continuerTransit) {
            accesTransit();
        }
        else if (e.getSource() == retourCaractEtoile) {
        	accesCaractEtoile();
        }
        else if (e.getSource() == relGraph) {
        	graphC.relancerGraph();
        }       
    }
    
    
    /** Abscisse en pixels sur la carte ==> degrs **/
    public double AbscInCoord (int abscPixel) {
    	double minAscDroite = Math.min(stringToCoord(strAd1,true),stringToCoord(strAd2,true));
    	double maxAscDroite = Math.max(stringToCoord(strAd1,true),stringToCoord(strAd2,true));
    	double coordX = widthCarte - (((abscPixel-minAscDroite)/(maxAscDroite-minAscDroite))*widthCarte);
    	double Xpix = (((widthCarte-abscPixel)*(maxAscDroite-minAscDroite))/widthCarte)+minAscDroite;
    	return (Xpix);
    }
    
    /** Ordonne en pixels sur la carte ==> degrs **/
    public double OrdoInCoord (int ordoPixel) {
    	double minDecl = Math.min(stringToCoord(strDecl1,false),stringToCoord(strDecl2,false));
    	double maxDecl = Math.max(stringToCoord(strDecl1,false),stringToCoord(strDecl2,false));
    	double coordY = heightCarte - (((ordoPixel-minDecl)/(maxDecl-minDecl))*heightCarte);
    	double Ypix = (((heightCarte-ordoPixel)*(maxDecl-minDecl))/heightCarte)+minDecl;
    	return (Ypix);
    }
    
    /** Abscisse en degrs sur la carte ==> pixels **/
    public int CoordInAbsc (double abscCoord, double ascDr1, double ascDr2) {
    	double minAscDroite = Math.min(ascDr1,ascDr2);
    	double maxAscDroite = Math.max(ascDr1,ascDr2);
    	double coordX = widthCarte - (((abscCoord-minAscDroite)/(maxAscDroite-minAscDroite))*widthCarte);
    	return ((int)coordX);
    }
    
    /** Ordonne en degrs sur la carte ==> pixels **/
    public int CoordInOrdo (double ordCoord, double decl1, double decl2) {
    	double minDecl = Math.min(decl1,decl2);
    	double maxDecl = Math.max(decl1,decl2);
    	double coordY = heightCarte - (((ordCoord-minDecl)/(maxDecl-minDecl))*heightCarte);
    	return ((int)coordY);
    }
    
    
    /** Conversion String param applet (unite separe par :) en double (selon Degre ou Horaire) **/
    public static double stringToCoord(String s, boolean uniteHoraire) throws NumberFormatException {
        int posSep1, posSep2;
        double unitPrinc, minutes, secondes;
        int signe = 1;
        posSep1 = s.indexOf(':');
        if (posSep1 == -1) throw new NumberFormatException();
        posSep2 = s.substring(posSep1 + 1).indexOf(':');
        if (posSep2 == -1) throw new NumberFormatException();
        posSep2 += posSep1 + 1;
        unitPrinc = (new Double(s.substring(0, posSep1))).doubleValue();
        minutes = (new Double(s.substring(posSep1 + 1, posSep2))).doubleValue();
        secondes = (new Double(s.substring(posSep2 + 1))).doubleValue();
        if (unitPrinc < 0) signe = -1;
        if (uniteHoraire) return(unitPrinc*15 + signe*minutes/4 + signe*secondes/240);
        else return(unitPrinc + signe*minutes/60 + signe*secondes/3600);
    }
    
    
    /** Conversion String param applet (unite separe par :) en String format **/
    public static String stringToFString(String s, boolean uniteHoraire) throws NumberFormatException {
        int posSep1, posSep2;
        String unitPrinc, minutes, secondes;
        int signe = 1;
        posSep1 = s.indexOf(':');
        if (posSep1 == -1) throw new NumberFormatException();
        posSep2 = s.substring(posSep1 + 1).indexOf(':');
        if (posSep2 == -1) throw new NumberFormatException();
        posSep2 += posSep1 + 1;
        unitPrinc = s.substring(0, posSep1);
        minutes = s.substring(posSep1 + 1, posSep2);
        secondes = s.substring(posSep2 + 1);
        if (minutes.length() == 1) minutes = "0" + minutes;        
        if (uniteHoraire) return(unitPrinc + "h" + minutes + "m" + secondes + "s");
        else return(unitPrinc + "" + minutes + "'" + secondes + "\"");
    }    
    
    
    /** Conversion Degre ou Horaire en String format **/
    public static String coordToFString(double coord, boolean uniteHoraire) { 
    	String unitPrinc, minutes, secondes;
        double d1,d2,d3;
        String signe;
        if (coord < 0) {
            signe = "-";
            coord = -coord;
        } else {
            signe = "";        	
        }
        if (uniteHoraire) {
            d1 = Math.floor(coord/15.0);
            d2 = Math.floor((coord-(d1*15.0)) * 4);
            d3 = (coord-(d1*15.0)-(d2/4.0))*240.0;
            unitPrinc = String.valueOf((int)d1);
            minutes = String.valueOf((int)d2);
            secondes = String.valueOf(df2.format(d3));
        } else {
        	d1 = Math.floor(coord);
            d2 = Math.floor(Math.rint((coord - d1) * 3600)/60);
            d3 = Math.abs((coord-d1-(d2/60.0))*3600);
            unitPrinc = String.valueOf((int)d1);
            minutes = String.valueOf((int)d2);
            secondes = String.valueOf(df2.format(d3));
        }
        if (minutes.length() == 1) minutes = "0" + minutes;
        if (uniteHoraire) return(signe + unitPrinc + "h" + minutes + "m" + secondes + "s");
        else return(signe + unitPrinc + "" + minutes + "'" + secondes + "\"");
    }    

    
    /** clic sur une etoile de la carte **/ 
	public void accesCaractEtoile() {
		Label labTemp;
		Color resultColor = new Color(141,119,95);
		mainPanel.removeAll();
		selectTypeSpectral = typeSpectral();
		RayonEtoile = typeSpecToRayon();
		MasseEtoile = typeSpecToMasse();
		LumEtoile = typeSpecToLum();
		TempEtoile = typeSpecToTemp();
		mainPanel.setForeground(Color.black);	
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = 0;
		c.gridy = 0;
	    c.gridwidth = 2;		
        mainPanel.add(new Label(""),c);			
	    c.gridy = 1;
	    Label titre = new Label(Messages.get("ETUDE"));
	    titre.setForeground(Color.red);
		mainPanel.add(titre,c);
		c.gridy = 2;
        mainPanel.add(new Label(""),c);		
		c.gridy = 3;
		c.anchor = GridBagConstraints.WEST;
        mainPanel.add(new Label(Messages.get("donnes_observables_1")),c);
        c.gridy = 4;
        mainPanel.add(new Label(Messages.get("donnes_observables_2")),c);
        c.gridy = 5;
        labTemp = new Label("   - " + Messages.get("Ascension_Droite") + " " + coordToFString(AbscInCoord (selectAbsc),true));
        labTemp.setForeground(resultColor);
		mainPanel.add(labTemp,c);
        c.gridy = 6;
        labTemp = new Label("   - " + Messages.get("Dclinaison") + " " + coordToFString(OrdoInCoord (selectOrdo),false));
        labTemp.setForeground(resultColor);
        mainPanel.add(labTemp,c);
        c.gridy = 7;
        labTemp = new Label("   - " + Messages.get("Magnitude_I") + " " + selectI);
        labTemp.setForeground(resultColor);        
        mainPanel.add(labTemp,c);
        c.gridy = 8;
        labTemp = new Label("   - " + Messages.get("Magnitude_J") + " " + selectJ);
        labTemp.setForeground(resultColor);        
        mainPanel.add(labTemp,c);	
        c.gridy = 9;
        labTemp = new Label("   - " + Messages.get("Magnitude_K") + " " + selectK);
        labTemp.setForeground(resultColor);        
        mainPanel.add(labTemp,c);	
        c.gridy = 10;       
		mainPanel.add(new Label(""),c);
        c.gridy = 11;       
		mainPanel.add(new Label(Messages.get("dterminer_type")),c);		
        c.gridy = 12;
        mainPanel.add(new Label(Messages.get("attribue")),c);
        c.gridy = 13;
        labTemp = new Label(Messages.get("type_spectral") + " " + selectTypeSpectral);
        labTemp.setForeground(resultColor); 		
        mainPanel.add(labTemp,c);
        c.gridy = 14;       
		mainPanel.add(new Label(""),c);
		mainPanel.setForeground(Color.black);
        c.gridy = 15;       
		mainPanel.add(new Label(Messages.get("extrapoler")),c);
        c.gridy = 16;       
		mainPanel.add(new Label(Messages.get("cette_toile")),c);
        c.gridy = 17;
        labTemp = new Label("   - " + Messages.get("sa_Masse") + " " + MasseEtoile[0] + " " + Messages.get("de_soleil") + " " + MasseEtoile[1] + " " + Messages.get("Kg_p"));
        labTemp.setForeground(resultColor);        
        mainPanel.add(labTemp,c);
        c.gridy = 18;       
        labTemp = new Label("   - " + Messages.get("son_Rayon") + " " + RayonEtoile[0] + " " + Messages.get("de_soleil") + " " + RayonEtoile[1] + " " + Messages.get("Km_p"));
        labTemp.setForeground(resultColor);        
        mainPanel.add(labTemp,c);
        c.gridy = 19;       
        labTemp = new Label("   - " + Messages.get("sa_Luminosit") + " " + LumEtoile[0] + " " + Messages.get("de_soleil") + " " + LumEtoile[1] + " " + Messages.get("Watt_p"));
        labTemp.setForeground(resultColor);        
        mainPanel.add(labTemp,c);
        c.gridy = 20;
        labTemp = new Label("   - " + Messages.get("sa_Temprature") + " " + TempEtoile[0] + " " + Messages.get("Kelvin_environ"));
        labTemp.setForeground(resultColor);        
        mainPanel.add(labTemp,c);        
		c.gridy = 21;		
		mainPanel.add(new Label(""),c);
		c.gridy = 22;		
		mainPanel.add(new Label(""),c);
		c.gridx = 0;
		c.gridy = 23;
		c.gridwidth = 1;
        c.anchor = GridBagConstraints.WEST;
		retourCarte = new Button(Messages.get("Retour_carte"));
		retourCarte.setForeground(new Color(102,102,240));
		retourCarte.addActionListener(this);
		mainPanel.add(retourCarte,c);
		c.gridx = 1;
		c.anchor = GridBagConstraints.EAST;
		continuerTransit = new Button(Messages.get("Continuer"));
		continuerTransit.setForeground(new Color(102,102,240));
		continuerTransit.addActionListener(this);
		mainPanel.add(continuerTransit,c);
		validate();
	}

	
	/** retourne typeSpectral **/
	public String typeSpectral() {
		if (selectI!=null && selectJ!=null && selectK!=null) {
			double distmin = 1000000.0;
			int resultat = -1;
			double av = 2.1;
			for (int i=0; i<this.nbVarPhotTot; i++) {
				double tempo = Math.pow((Double.valueOf(selectI).doubleValue()-Double.valueOf(selectJ).doubleValue()-av*(.482 - .282)-Double.valueOf(photTotIJ[i]).doubleValue()),2)+Math.pow((Double.valueOf(selectJ).doubleValue()-Double.valueOf(selectK).doubleValue()-av*(.282 - .112)-Double.valueOf(photTotJK[i]).doubleValue()),2);
				if (tempo<distmin) {
					distmin=tempo;
					resultat=i;
				}
			}
			if (resultat!=-1) return photTotType[resultat];
			else return "??";
		} 
		else return "??";
	}
	

	/** retourne rayon de l'etoile en fonction du typeSpectral **/	
	public String[] typeSpecToRayon() {
	    double[] logr = {1.25,0.87,0.58,0.4,0.24,0.13,0.08,0.02,-0.3,-0.7,-0.13,-0.2,-0.5};
		String[] resultRayon = new String[3];
		String star = "OBAFGKM";
		if (!selectTypeSpectral.equals("??")) {
			int pos_star = star.lastIndexOf(String.valueOf(selectTypeSpectral.charAt(0)));
			int rang = Integer.valueOf(String.valueOf(selectTypeSpectral.charAt(1))).intValue();
			double spn = (pos_star*10+rang)/5.-1;
			if (spn>=0 && spn<=(logr.length-1)) {
				double rapport = Math.pow(10,interpolate(logr,spn));
				resultRayon[0]=df2.format(rapport*100);
				resultRayon[1]=df2.format(rapport*696000);
				resultRayon[2]=String.valueOf(rapport*696000);
			} else {
				resultRayon[0]="??";
				resultRayon[1]="??";
				resultRayon[2]="??";
			}
		} 
		else {
			resultRayon[0]="??";
			resultRayon[1]="??";
			resultRayon[2]="??";
		}
		return resultRayon;
	}
	

	/** retourne masse de l'etoile en fonction du typeSpectral **/
	public String[] typeSpecToMasse() {
	    double[] logm = {1.6,1.25,0.81,0.51,0.32,0.23,0.11,0.04,-0.03,-0.11,-0.16,-0.33,-0.67};
		String[] resultMass = new String[3];
		String star= "OBAFGKM";
		if (!selectTypeSpectral.equals("??")) {
			int pos_star = star.lastIndexOf(String.valueOf(selectTypeSpectral.charAt(0)));
			int rang = Integer.valueOf(String.valueOf(selectTypeSpectral.charAt(1))).intValue();
			double spn = (pos_star*10+rang)/5.-1;
			if (spn>=0 && spn<=(logm.length-1)) {
				double rapport = Math.pow(10,interpolate(logm,spn));
				resultMass[0]=df2.format(rapport*100);
				resultMass[1]=FormateBigDouble(rapport*1.9891E030D);
				resultMass[2]=String.valueOf(rapport);
			} else {
				resultMass[0]="??";
				resultMass[1]="??";
				resultMass[2]="??";
			}
		} 
		else {
			resultMass[0]="??";
			resultMass[1]="??";
			resultMass[2]="??";
		}
		return resultMass;
	}


	/** retourne temperature de l'etoile en fonction du typeSpectral **/
	public String[] typeSpecToTemp() {
		double[] logt = {4.602,4.447,4.19,3.996,3.929,3.869,3.818,3.78,3.742,3.69,3.616,3.542,3.447};
		String[] resultTemp = new String[2];
		String star= "OBAFGKM";
		if (!selectTypeSpectral.equals("??")) {
			int pos_star = star.lastIndexOf(String.valueOf(selectTypeSpectral.charAt(0)));
			int rang = Integer.valueOf(String.valueOf(selectTypeSpectral.charAt(1))).intValue();
			double spn = (pos_star*10+rang)/5.-1;
			if (spn>=0 && spn<=(logt.length-1)) {
				double thisTemp = Math.pow(10,interpolate(logt,spn));
				resultTemp[0]=df2.format(thisTemp);
				resultTemp[1]="??";
			} else {
				resultTemp[0]="??";
				resultTemp[1]="??";
			}
		} 
		else {
			resultTemp[0]="??";
			resultTemp[1]="??";
		}
		return resultTemp;			
	}
	

	/** retourne luminosite de l'etoile en fonction du typeSpectral **/
	public String[] typeSpecToLum() {
	    double[] logl = {5.7,4.3,2.9,1.9,1.3,0.8,0.4,0.1,-0.1,-0.4,-0.8,-1.2,-2.1};
		String[] resultLum = new String[3];
		String star= "OBAFGKM";
		if (!selectTypeSpectral.equals("??")) {
			int pos_star = star.lastIndexOf(String.valueOf(selectTypeSpectral.charAt(0)));
			int rang = Integer.valueOf(String.valueOf(selectTypeSpectral.charAt(1))).intValue();
			double spn = (pos_star*10+rang)/5.-1;
			if (spn>=0 && spn<=(logl.length-1)) {
				double rapport = Math.pow(10,interpolate(logl,spn));
				resultLum[0]=df2.format(rapport*100);
				resultLum[1]=FormateBigDouble(rapport*3.826E026D);
				resultLum[2]=String.valueOf(rapport);
			} else {
				resultLum[0]="??";
				resultLum[1]="??";
				resultLum[2]="??";
			}
		} 
		else {
			resultLum[0]="??";
			resultLum[1]="??";
			resultLum[2]="??";
		}
		return resultLum;
	}	

	
	/** formater double en 10^ **/
    public static String FormateBigDouble(double d)
    {
        int i = 3;
        byte byte0 = 3;
        if (d == 0.0D) return "0";
        String s = "" + d;
        if ("Infinity".equals(s) || "-Infinity".equals(s) || "NaN".equals(s)) return "" + d;
        String s1;
        if (d >= 0.0D) {
            s1 = "";
        } 
        else {
            d = -d;
            s1 = "-";
        }
        int j = (int)Math.floor(Math.log(d) / Math.log(10D));
        double d1 = Math.pow(10D, i);
        double d2 = d / Math.pow(10D, j);
        d2 = Math.rint(d2 * d1) / d1;
        if (d2 >= 10D) {
            j++;
            d2 = d / Math.pow(10D, j);
            d2 = Math.rint(d2 * d1) / d1;
        }
        String s2 = "";
        int l = (int)Math.floor(d2);
        s2 = s2 + l + ".";
        for (int i1 = 0; i1 < i - 1; i1++) {
            d2 = (d2 - (double)l) * 10D;
            double d3 = Math.pow(10D, i - i1);
            d2 = Math.rint(d2 * d1) / d1;
            l = (int)Math.floor(d2);
            s2 = s2 + l;
        }
        d2 = (d2 - (double)l) * 10D;
        l = (int)Math.round(d2);
        s2 = s2 + l;
        for (char c1 = s2.charAt(s2.length() - 1); c1 == '0'; c1 = s2.charAt(s2.length() - 1))
            s2 = s2.substring(0, s2.length() - 1);
        if (j != 0)
            if (j > 0 && j < byte0)
            {
                String s3 = s2.substring(0, 1);
                if(s2.length() - 2 < j) {
                    if (s2.length() > 2)
                        s3 = s3 + s2.substring(2, s2.length());
                    for (int j1 = 0; j1 < j - (s2.length() - 2); j1++)
                        s3 = s3 + '0';
                } else
                if(s2.length() < j + 2)
                    s3 = s3 + s2.substring(2);
                else
                    s3 = s3 + s2.substring(2, j + 2) + "." + s2.substring(j + 2);
                s2 = s3;
            } else
            if (j < 0 && j > -byte0) {
                String s4 = "0.";
                for(int k1 = 0; k1 < -j - 1; k1++)
                    s4 = s4 + '0';
                s2 = s4 + s2.charAt(0) + s2.substring(2);
            } else {
                if(s2.charAt(s2.length() - 1) == '.')
                    s2 = s2.substring(0, s2.length() - 1);
                s2 = s2 + ".10^" + j;
            }
        if(s2.charAt(s2.length() - 1) == '.')
            s2 = s2.substring(0, s2.length() - 1);
        s2 = s1 + s2;
        return s2;
    }	

	
	/** interpolation de courbe **/
    // fonctionne car pente presque droite (mais algo a trouver % pente !?)
	public double interpolate(double[] thisLog, double val) {
		double result;
        int valAbs = (int)val;
        double diff = val - valAbs;
        if (diff!=0) result = thisLog[valAbs] - diff * (thisLog[valAbs]-thisLog[valAbs+1]);
        else result = thisLog[(int)val];
        return result;
	}
	
	
	/** retour  la carte **/
	public void retourCarte() {
		removeAll();
		carteC.retour = true;
		champCorot();
		validate();
	}

	
	/** Acces au panel sur les transits **/
	public void accesTransit() {
		Color backgColor = new Color(230, 221, 212);
		mainPanel.removeAll();
		validate();
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = 0;
		c.gridy = 0;
		c.gridwidth = 2;
		mainPanel.setForeground(Color.black);
		mainPanel.add(new Label(Messages.get("Courbe_lumire")),c);
		c.gridy = 1;		
        graphC = new graphCanvas(560, 300, MasseEtoile[2], LumEtoile[2], RayonEtoile[2], selectK, this);
	    graph = createImage(560, 300);
	    mainPanel.add(graphC,c);
	    c.gridy = 2;	
		c.gridwidth = 1;
		c.anchor = GridBagConstraints.CENTER;
		txtGraph1 = new Label("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
		txtGraph1.setForeground(backgColor);
		txtGraph1.setAlignment(1);
		mainPanel.add(txtGraph1,c);
		c.gridx = 1;
		c.anchor = GridBagConstraints.EAST;
		relGraph = new Button(Messages.get("Relancer_graphe"));
		relGraph.setForeground(new Color(102,102,240));
		relGraph.disable();
		relGraph.addActionListener(this);
		mainPanel.add(relGraph,c);
		c.gridy = 3;
		c.gridx = 0;
		c.gridwidth = 2;
		mainPanel.add(new Label(""),c);
		c.anchor = GridBagConstraints.WEST;
		c.gridy = 4;
		c.gridx = 0;
		c.gridwidth = 2;
		txtGraph2 = new Label("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
		txtGraph2.setForeground(backgColor);
		txtGraph2.setAlignment(0);
		mainPanel.add(txtGraph2,c);
		c.gridy = 5;
		c.gridx = 0;
		c.gridwidth = 2;
		txtGraph3 = new Label("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
		txtGraph3.setForeground(backgColor);
		txtGraph3.setAlignment(0);		
		mainPanel.add(txtGraph3,c);
		c.gridy = 6;
		c.gridx = 0;
		c.gridwidth = 2;
		txtGraph4 = new Label("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
		txtGraph4.setForeground(backgColor);
		txtGraph4.setAlignment(0);		
		mainPanel.add(txtGraph4,c);
		c.gridy = 7;
		c.gridx = 0;
		c.gridwidth = 2;
		txtGraph5 = new Label("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
		txtGraph5.setForeground(backgColor);
		txtGraph5.setAlignment(0);		
		mainPanel.add(txtGraph5,c);
		c.gridy = 8;
		c.gridx = 0;
		c.gridwidth = 2;
		txtGraph6 = new Label("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
		txtGraph6.setForeground(backgColor);
		txtGraph6.setAlignment(0);		
		mainPanel.add(txtGraph6,c);
		c.gridy = 9;
		c.gridx = 0;
		c.gridwidth = 2;
		txtGraph7 = new Label("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
		txtGraph7.setForeground(backgColor);
		txtGraph7.setAlignment(0);		
		mainPanel.add(txtGraph7,c);
		c.gridy = 10;
		c.gridx = 0;
		c.gridwidth = 2;
		txtGraph8 = new Label("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX");
		txtGraph8.setForeground(backgColor);
		txtGraph8.setAlignment(0);		
		mainPanel.add(txtGraph8,c);		
		c.gridy = 11;
		c.gridx = 0;
		c.gridwidth = 2;
		mainPanel.add(new Label(""),c);		
		c.gridy = 12;
		c.gridx = 0;
		c.gridwidth = 1;
		c.anchor = GridBagConstraints.WEST;
		retourCaractEtoile = new Button(Messages.get("Retour_donnes"));
		retourCaractEtoile.addActionListener(this);
		retourCaractEtoile.setForeground(new Color(102,102,240));
		retourCaractEtoile.disable();
		mainPanel.add(retourCaractEtoile,c);			
		c.gridx = 1;
		c.anchor = GridBagConstraints.EAST;
		retourCarte = new Button(Messages.get("Retour_carte"));
		retourCarte.addActionListener(this);
		retourCarte.setForeground(new Color(102,102,240));
		retourCarte.disable();
		mainPanel.add(retourCarte,c);
		validate();		
	}
	
}